angular.module(\app).service do
    * \activityWidget
    * ($xabl, p, debug, $root-scope, ablbook, ablslot, $window, $q)->
          $root-scope.close = ->
             debug \close
             widget.change \calendar
             $window.close!
          get-param = (name)->
                    switch name 
                      case \activity1
                        return "571ea4cb65cea94c1190762e"
                      case \event1
                        return "7785bu94lcgrtud4m23ptqotl4_20160616T190000Z"
                    #debug
                    window
                      .location
                      .search.substr(1)
                      .split(\&)
                      .map(-> it.split(\=))
                      .filter(-> it.0 is name)
                      .map(->it.1).0
          
          const widget =
            setup: (options)->
              $xabl.setup options
              load!
            screen: \loading
            disallow-discovery: ->
                widget.disallowed-discovery = yes
            current-activity: null
            disallowed-discovery: no
            
            # connect sdk ------------------------------------------------------
            set-current-activity: (activity)->  
                return if !activity?
                widget.current-activity = activity
                widget.book = 
                      ablbook activity, (status, data)->
                        if status is \success
                           widget.change \success
                        if status is \slot-chosen and data
                           widget.change \pricing
                widget.slot = ablslot activity, widget.book.calendar
                widget.slot.observe (name)->
                    debug \observe, name
                    switch name
                        case \load-slot-list-complete
                          return if state.list-complete
                          state.list-complete = yes
                          day-param = get-param \day
                          next = (day)->
                              console.log \day, day.format!
                              return if not day.is-valid!
                              widget.slot.set-month day
                              
                              if widget.slot.is-disabled-day(day)
                                return debug "day is disabled", day.format!
                              widget.slot.select-day(day) 
                              widget.change \timeslots 
                          if day-param?
                             day = moment.tz(day-param, widget.current-activity.time-zone).start-of(\day)
                             next day
                        case \event-sold-out
                           $root-scope.sold-out-text = if angular.is-undefined($root-scope.user.preferences.eventSoldOutText) then null else (if $root-scope.user.preferences.eventSoldOutText is '' then null else $root-scope.user.preferences.eventSoldOutText )
                           widget.change \sold-out
                        case \event-too-close
                           widget.change \too-close
                        case \event-not-found
                           widget.change \calendar
                #window.prefill?!
                widget.bg = background-image: "url(#{activity.images[0]})" 
                widget.title!
            title: (name)->
              #widget.preferences.features.questions
              items = 
                 * [\gallery, "Select activity", no]
                 * [\calendar, "Select Day", !get-param("event")?]
                 * [\timeslots, "Select Time", !get-param("event")?]
                 * [\pricing, "Select Quantity", yes]
                 * [\details, "Personal Information", yes]
                 * [\review, "Checkout", yes]
                 * [\success, "Confirmation", no]
              enabled-items = items |> p.filter (.2) |> p.map (-> [it.0, it.1]) 
              pages = items |> p.map (-> [it.0, it.1]) |> p.pairs-to-obj
              title = pages[name] ? name
              page =
                enabled-items |> p.find (.0 is name) |> (-> enabled-items.index-of(it) + 1)
              
              $root-scope.title = 
                 | name is title => title 
                 | page is 0 => title
                 | _ => "#{title} (#{page} of #{enabled-items.length})"
            change: (name)->
                try 
                  $(window).scrollTop 0
                  switch name
                       case \loading then  widget.title(\loading...)
                       else widget.title(name)
                  widget.screen = name
                  load! if name is \loading
                catch error 
                   alert error
            possible-activities: []
          state = 
             page: 0
             location: []
             
             
          load = (callback)->
            #pageSize=100&page=0&dateRange[]=2015-09-20T07:00:00.000Z&dateRange[]=2015-04--01T07:00:00.000Z
            config = $.param do
              location: state.location
              page-size: 100
              page: state.page
              no-empty: no
              date-range: 
                * moment!.start-of(\day).format!
                * moment!.clone!.add(18, \months).end-of(\day).format!
            debug config
            $q
              .all do 
                 * * $xabl.get "operators/#{$xabl.options.key}"
                   * $xabl.get "activities?#config"
              .then do  
                  * (resps)->
                      resp = 
                         resps |> p.map (.data)
                      debug \payment resp
                      if resp.0.currency
                        $root-scope.currency = resp.0.currency;
                        #resp.0.currency
                      else
                        $root-scope.currency = "usd"
                           
                      $root-scope.company-name = resp.0.primaryContact.full-name
                      $root-scope.phone-number = resp.0.primaryContact.phone-number
                      $root-scope.email = resp.0.primaryContact.email

                      widget.possible-activities.length = 0
                      push = (item) ->
                        widget.possible-activities.push item
                      widget.preferences = 
                          angular.extend {}, resp.1.preferences, resp.0.preferences
                      debug widget.preferences, resp.1.preferences, resp.0.preferences
                      $root-scope.user =
                        preferences: widget.preferences
                      resp.1.list |> p.each push
                      id = get-param \activity
                      next-page = 
                        | typeof! resp.1.list isnt \Array or resp.1.list.length is 0 => \no-data
                        | id? => \calendar
                        | _ => \gallery
                      
                      if next-page is \calendar
                        activity = 
                          widget.possible-activities |> p.find(-> it._id is id)
                        widget.set-current-activity activity
                        event = get-param(\event)
                        if activity? and event?
                          widget.slot.choose-event(get-param(\event))
                          widget.disallow-discovery!
                          #widget.change next-page
                          return callback?!
                      widget.change next-page
                      callback?!
            
            
            
                   
            
                
                
          widget.load = load
          
          widget
