angular.module(\app).directive do
    * \activityWidget
    * (activity-widget, template, $xabl, $root-scope, debug)->
          restrict: \E
          scope:
            merchant: \=
          replace: yes
          template-url: template \activity_widget
          link: ($scope)->
              
              $scope
                ..agree = ->
                  activity-widget.book.form.agreed = yes
                  activity-widget.change \review
                ..widget = activity-widget
                ..$watch \merchant, ->
                  activity-widget.setup do
                    key: $scope.merchant
                    secure: no
                ..change = activity-widget.change
                ..info = 
                  company-name: "Company Name"
                  phone-number: "Phone Number"
                  email: "Email"
                ..$watch (-> $root-scope.sold-out-text), ((n, o) !->
                  if n
                    $scope.sold-out-text = n )
                ..$watch (-> $root-scope.company-name), ((n, o) !->
                  if n
                    $scope.company-name = n )
                ..$watch (-> $root-scope.phone-number), ((n, o) !->
                  if n
                    $scope.phone-number = n )
                ..$watch (-> $root-scope.email), ((n, o) !->
                  if n
                    $scope.email = n )